#include <inttypes.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

uint32_t
fxexp(const uint32_t argx)
{
	uint32_t	x;
	uint32_t	y;
	int32_t		t;

	x = argx;
	y=0x00010000;
	t=x-0x58b91; if(t>=0) { x=t;y<<=8; }
	t=x-0x2c5c8; if(t>=0) { x=t;y<<=4; }
	t=x-0x162e4; if(t>=0) { x=t;y<<=2; }
	t=x-0x0b172; if(t>=0) { x=t;y<<=1; }
	t=x-0x067cd; if(t>=0) { x=t;y+=y>>1; }
	t=x-0x03920; if(t>=0) { x=t;y+=y>>2; }
	t=x-0x01e27; if(t>=0) { x=t;y+=y>>3; }
	t=x-0x00f85; if(t>=0) { x=t;y+=y>>4; }
	t=x-0x007e1; if(t>=0) { x=t;y+=y>>5; }
	t=x-0x003f8; if(t>=0) { x=t;y+=y>>6; }
	t=x-0x001fe; if(t>=0) { x=t;y+=y>>7; }
	if(x&0x100)                 y+=y>>8;
	if(x&0x080)                 y+=y>>9;
	if(x&0x040)                 y+=y>>10;
	if(x&0x020)                 y+=y>>11;
	if(x&0x010)                 y+=y>>12;
	if(x&0x008)                 y+=y>>13;
	if(x&0x004)                 y+=y>>14;
	if(x&0x002)                 y+=y>>15;
	if(x&0x001)                 y+=y>>16;
	return y;
}


uint32_t
fxlog(const uint32_t argx)
{
	uint32_t	t;
	uint32_t	x;
	uint32_t	y;

	x = argx;
	y=0xa65af;
	if(x<0x00008000) x<<=16,                y-=0xb1721;
	if(x<0x00800000) x<<= 8,                y-=0x58b91;
	if(x<0x08000000) x<<= 4,                y-=0x2c5c8;
	if(x<0x20000000) x<<= 2,                y-=0x162e4;
	if(x<0x40000000) x<<= 1,                y-=0x0b172;
	t=x+(x>>1); if((t&0x80000000)==0) { x=t;y-=0x067cd; }
	t=x+(x>>2); if((t&0x80000000)==0) { x=t;y-=0x03920; }
	t=x+(x>>3); if((t&0x80000000)==0) { x=t;y-=0x01e27; }
	t=x+(x>>4); if((t&0x80000000)==0) { x=t;y-=0x00f85; }
	t=x+(x>>5); if((t&0x80000000)==0) { x=t;y-=0x007e1; }
	t=x+(x>>6); if((t&0x80000000)==0) { x=t;y-=0x003f8; }
	t=x+(x>>7); if((t&0x80000000)==0) { x=t;y-=0x001fe; }
	x=0x80000000-x;
	y-=x>>15;
	return y;
}

#if 0
uint64_t
divmod(uint64_t *q, uint64_t *r, uint64_t x, uint64_t y)
{
	uint32_t	xlog;
	uint32_t	ylog;

	xlog = fxlog(x >> 16);
	ylog = fxlog(y >> 16);
	*q = fxexp(
}
#endif

#if 0
int
longdiv(uint64_t *q, uint64_t *r, uint64_t x, uint64_t y)
{
	union un {
		uint64_t	i64;
		uint32_t	i32[2];
	} newx, newy;

	if (y == 0) {
		return 0;
	}
	if (x == 0 || y == 1) {
		(void) memcpy(q, &x, sizeof(*q));
		(void) memset(r, 0x0, sizeof(*r));
		return 1;
	}
	newx.i64 = x;
	newy.i64 = y;
	for (i = 1 ; i >= 0 ; --i) {
		
	}
	return 1;
}
#endif

int
main(int argc, char **argv)
{
	uint32_t	n;
	int		i;

	for (i = optind ; i < argc ; i++) {
		n = strtoul(argv[i], NULL, 0);
		printf("n %#x, log %#x, exp %#x\n", n, fxlog(n << 16), fxexp(n << 16));
		printf("n %#x, new n %#x\n", n, fxexp(fxlog(n)));
	}
	exit(EXIT_SUCCESS);
}
